//+------------------------------------------------------------------+
//|                                                      TestIND.mq4 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

string names[3] = {"USDJPY","EURJPY","EURUSD"};

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping

   for (int i = 0; i < ArraySize(names); i++) {
      if(ObjectFind(0 , names[i]) < 0) {
         if(!ObjectCreate(0 , names[i] , OBJ_LABEL, 0 , 0 , 0)) {
            Print(__FUNCTION__, ": failed to create Label ! Error code = ",GetLastError());
            return(INIT_FAILED);
         }
      }
      ObjectSetInteger(0, names[i], OBJPROP_XDISTANCE   ,10);
      ObjectSetInteger(0, names[i], OBJPROP_YDISTANCE   ,i * 20 + 20);
      ObjectSetInteger(0, names[i], OBJPROP_CORNER      ,CORNER_LEFT_UPPER);
      ObjectSetString (0, names[i], OBJPROP_TEXT        ,names[i]);
      ObjectSetString (0, names[i], OBJPROP_FONT        ,"Arial");
      ObjectSetInteger(0, names[i], OBJPROP_FONTSIZE    ,14);  
      ObjectSetInteger(0, names[i], OBJPROP_COLOR       ,clrWhite);
      ObjectSetInteger(0, names[i], OBJPROP_BACK        ,false);
      ObjectSetInteger(0, names[i], OBJPROP_SELECTABLE  ,false);   
      ObjectSetInteger(0, names[i], OBJPROP_SELECTED    ,false);
      ObjectSetInteger(0, names[i], OBJPROP_HIDDEN      ,false);
      ObjectSetInteger(0, names[i], OBJPROP_ZORDER      ,0);
     
   }  
   
   ChartRedraw(0);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   if (id == CHARTEVENT_OBJECT_CLICK) {
      if (sparam == names[0] || sparam == names[1] || sparam == names[2]){
         ChartSetSymbolPeriod(0 , sparam , 0);
      }
   }
   
  }
//+------------------------------------------------------------------+
